# coding: utf-8

"""
Copyright 2015 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from pprint import pformat
from six import iteritems


class ComputerSystem100MemorySummary(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        ComputerSystem100MemorySummary - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'status': 'ResourceStatus',
            'total_system_memory_gi_b': 'float'
        }

        self.attribute_map = {
            'status': 'Status',
            'total_system_memory_gi_b': 'TotalSystemMemoryGiB'
        }

        self._status = None
        self._total_system_memory_gi_b = None

    @property
    def status(self):
        """
        Gets the status of this ComputerSystem100MemorySummary.


        :return: The status of this ComputerSystem100MemorySummary.
        :rtype: ResourceStatus
        """
        return self._status

    @status.setter
    def status(self, status):
        """
        Sets the status of this ComputerSystem100MemorySummary.


        :param status: The status of this ComputerSystem100MemorySummary.
        :type: ResourceStatus
        """
        self._status = status

    @property
    def total_system_memory_gi_b(self):
        """
        Gets the total_system_memory_gi_b of this ComputerSystem100MemorySummary.
        The total installed, operating system-accessible memory (RAM), measured in GiB.

        :return: The total_system_memory_gi_b of this ComputerSystem100MemorySummary.
        :rtype: float
        """
        return self._total_system_memory_gi_b

    @total_system_memory_gi_b.setter
    def total_system_memory_gi_b(self, total_system_memory_gi_b):
        """
        Sets the total_system_memory_gi_b of this ComputerSystem100MemorySummary.
        The total installed, operating system-accessible memory (RAM), measured in GiB.

        :param total_system_memory_gi_b: The total_system_memory_gi_b of this ComputerSystem100MemorySummary.
        :type: float
        """
        self._total_system_memory_gi_b = total_system_memory_gi_b

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other): 
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """ 
        Returns true if both objects are not equal
        """
        return not self == other

