# coding: utf-8

"""
Copyright 2015 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from pprint import pformat
from six import iteritems


class EthernetInterfaceV110Links(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        EthernetInterfaceV110Links - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'endpoints': 'list[EndpointEndpoint]',
            'endpointsodata_count': 'float',
            'endpointsodata_navigation_link': 'Odata400IdRef',
            'oem': 'ResourceOem'
        }

        self.attribute_map = {
            'endpoints': 'Endpoints',
            'endpointsodata_count': 'Endpoints@odata.count',
            'endpointsodata_navigation_link': 'Endpoints@odata.navigationLink',
            'oem': 'Oem'
        }

        self._endpoints = None
        self._endpointsodata_count = None
        self._endpointsodata_navigation_link = None
        self._oem = None

    @property
    def endpoints(self):
        """
        Gets the endpoints of this EthernetInterfaceV110Links.
        An array of references to the endpoints that connect to this ethernet interface.

        :return: The endpoints of this EthernetInterfaceV110Links.
        :rtype: list[EndpointEndpoint]
        """
        return self._endpoints

    @endpoints.setter
    def endpoints(self, endpoints):
        """
        Sets the endpoints of this EthernetInterfaceV110Links.
        An array of references to the endpoints that connect to this ethernet interface.

        :param endpoints: The endpoints of this EthernetInterfaceV110Links.
        :type: list[EndpointEndpoint]
        """
        self._endpoints = endpoints

    @property
    def endpointsodata_count(self):
        """
        Gets the endpointsodata_count of this EthernetInterfaceV110Links.


        :return: The endpointsodata_count of this EthernetInterfaceV110Links.
        :rtype: float
        """
        return self._endpointsodata_count

    @endpointsodata_count.setter
    def endpointsodata_count(self, endpointsodata_count):
        """
        Sets the endpointsodata_count of this EthernetInterfaceV110Links.


        :param endpointsodata_count: The endpointsodata_count of this EthernetInterfaceV110Links.
        :type: float
        """
        self._endpointsodata_count = endpointsodata_count

    @property
    def endpointsodata_navigation_link(self):
        """
        Gets the endpointsodata_navigation_link of this EthernetInterfaceV110Links.


        :return: The endpointsodata_navigation_link of this EthernetInterfaceV110Links.
        :rtype: Odata400IdRef
        """
        return self._endpointsodata_navigation_link

    @endpointsodata_navigation_link.setter
    def endpointsodata_navigation_link(self, endpointsodata_navigation_link):
        """
        Sets the endpointsodata_navigation_link of this EthernetInterfaceV110Links.


        :param endpointsodata_navigation_link: The endpointsodata_navigation_link of this EthernetInterfaceV110Links.
        :type: Odata400IdRef
        """
        self._endpointsodata_navigation_link = endpointsodata_navigation_link

    @property
    def oem(self):
        """
        Gets the oem of this EthernetInterfaceV110Links.
        Oem extension object.

        :return: The oem of this EthernetInterfaceV110Links.
        :rtype: ResourceOem
        """
        return self._oem

    @oem.setter
    def oem(self, oem):
        """
        Sets the oem of this EthernetInterfaceV110Links.
        Oem extension object.

        :param oem: The oem of this EthernetInterfaceV110Links.
        :type: ResourceOem
        """
        self._oem = oem

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other): 
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """ 
        Returns true if both objects are not equal
        """
        return not self == other

