# coding: utf-8

"""
Copyright 2015 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from pprint import pformat
from six import iteritems


class IPAddressesV100IPv4Address(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        IPAddressesV100IPv4Address - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'address': 'str',
            'address_origin': 'IPAddressesV100IPv4AddressOrigin',
            'gateway': 'str',
            'oem': 'ResourceOem',
            'subnet_mask': 'IPAddressesV100SubnetMask'
        }

        self.attribute_map = {
            'address': 'Address',
            'address_origin': 'AddressOrigin',
            'gateway': 'Gateway',
            'oem': 'Oem',
            'subnet_mask': 'SubnetMask'
        }

        self._address = None
        self._address_origin = None
        self._gateway = None
        self._oem = None
        self._subnet_mask = None

    @property
    def address(self):
        """
        Gets the address of this IPAddressesV100IPv4Address.
        This is the IPv4 Address.

        :return: The address of this IPAddressesV100IPv4Address.
        :rtype: str
        """
        return self._address

    @address.setter
    def address(self, address):
        """
        Sets the address of this IPAddressesV100IPv4Address.
        This is the IPv4 Address.

        :param address: The address of this IPAddressesV100IPv4Address.
        :type: str
        """
        self._address = address

    @property
    def address_origin(self):
        """
        Gets the address_origin of this IPAddressesV100IPv4Address.
        This indicates how the address was determined.

        :return: The address_origin of this IPAddressesV100IPv4Address.
        :rtype: IPAddressesV100IPv4AddressOrigin
        """
        return self._address_origin

    @address_origin.setter
    def address_origin(self, address_origin):
        """
        Sets the address_origin of this IPAddressesV100IPv4Address.
        This indicates how the address was determined.

        :param address_origin: The address_origin of this IPAddressesV100IPv4Address.
        :type: IPAddressesV100IPv4AddressOrigin
        """
        self._address_origin = address_origin

    @property
    def gateway(self):
        """
        Gets the gateway of this IPAddressesV100IPv4Address.
        This is the IPv4 gateway for this address.

        :return: The gateway of this IPAddressesV100IPv4Address.
        :rtype: str
        """
        return self._gateway

    @gateway.setter
    def gateway(self, gateway):
        """
        Sets the gateway of this IPAddressesV100IPv4Address.
        This is the IPv4 gateway for this address.

        :param gateway: The gateway of this IPAddressesV100IPv4Address.
        :type: str
        """
        self._gateway = gateway

    @property
    def oem(self):
        """
        Gets the oem of this IPAddressesV100IPv4Address.


        :return: The oem of this IPAddressesV100IPv4Address.
        :rtype: ResourceOem
        """
        return self._oem

    @oem.setter
    def oem(self, oem):
        """
        Sets the oem of this IPAddressesV100IPv4Address.


        :param oem: The oem of this IPAddressesV100IPv4Address.
        :type: ResourceOem
        """
        self._oem = oem

    @property
    def subnet_mask(self):
        """
        Gets the subnet_mask of this IPAddressesV100IPv4Address.
        This is the IPv4 Subnet mask.

        :return: The subnet_mask of this IPAddressesV100IPv4Address.
        :rtype: IPAddressesV100SubnetMask
        """
        return self._subnet_mask

    @subnet_mask.setter
    def subnet_mask(self, subnet_mask):
        """
        Sets the subnet_mask of this IPAddressesV100IPv4Address.
        This is the IPv4 Subnet mask.

        :param subnet_mask: The subnet_mask of this IPAddressesV100IPv4Address.
        :type: IPAddressesV100SubnetMask
        """
        self._subnet_mask = subnet_mask

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other): 
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """ 
        Returns true if both objects are not equal
        """
        return not self == other

