# coding: utf-8

"""
Copyright 2015 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from pprint import pformat
from six import iteritems


class ManagerAccount100ManagerAccountLinks(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        ManagerAccount100ManagerAccountLinks - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'role': 'Odata400IdRef',
            'oem': 'ResourceOem'
        }

        self.attribute_map = {
            'role': 'Role',
            'oem': 'Oem'
        }

        self._role = None
        self._oem = None

    @property
    def role(self):
        """
        Gets the role of this ManagerAccount100ManagerAccountLinks.
        A reference to the Role object defining Privileges for this account--returned when the resource is read. The ID of the role is the same as property RoleId.

        :return: The role of this ManagerAccount100ManagerAccountLinks.
        :rtype: Odata400IdRef
        """
        return self._role

    @role.setter
    def role(self, role):
        """
        Sets the role of this ManagerAccount100ManagerAccountLinks.
        A reference to the Role object defining Privileges for this account--returned when the resource is read. The ID of the role is the same as property RoleId.

        :param role: The role of this ManagerAccount100ManagerAccountLinks.
        :type: Odata400IdRef
        """
        self._role = role

    @property
    def oem(self):
        """
        Gets the oem of this ManagerAccount100ManagerAccountLinks.
        Oem extension object.

        :return: The oem of this ManagerAccount100ManagerAccountLinks.
        :rtype: ResourceOem
        """
        return self._oem

    @oem.setter
    def oem(self, oem):
        """
        Sets the oem of this ManagerAccount100ManagerAccountLinks.
        Oem extension object.

        :param oem: The oem of this ManagerAccount100ManagerAccountLinks.
        :type: ResourceOem
        """
        self._oem = oem

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other): 
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """ 
        Returns true if both objects are not equal
        """
        return not self == other

