# coding: utf-8

"""
Copyright 2015 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from pprint import pformat
from six import iteritems


class Power100PowerSupply(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        Power100PowerSupply - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'firmware_version': 'str',
            'last_power_output_watts': 'float',
            'line_input_voltage': 'float',
            'line_input_voltage_type': 'str',
            'member_id': 'str',
            'model': 'str',
            'name': 'str',
            'oem': 'ResourceOem',
            'part_number': 'str',
            'power_capacity_watts': 'float',
            'power_supply_type': 'str',
            'redundancy': 'list[Odata400IdRef]',
            'redundancyodata_count': 'float',
            'redundancyodata_navigation_link': 'Odata400IdRef',
            'related_item': 'list[Odata400IdRef]',
            'related_itemodata_count': 'float',
            'related_itemodata_navigation_link': 'Odata400IdRef',
            'serial_number': 'str',
            'spare_part_number': 'str',
            'status': 'ResourceStatus'
        }

        self.attribute_map = {
            'firmware_version': 'FirmwareVersion',
            'last_power_output_watts': 'LastPowerOutputWatts',
            'line_input_voltage': 'LineInputVoltage',
            'line_input_voltage_type': 'LineInputVoltageType',
            'member_id': 'MemberId',
            'model': 'Model',
            'name': 'Name',
            'oem': 'Oem',
            'part_number': 'PartNumber',
            'power_capacity_watts': 'PowerCapacityWatts',
            'power_supply_type': 'PowerSupplyType',
            'redundancy': 'Redundancy',
            'redundancyodata_count': 'Redundancy@odata.count',
            'redundancyodata_navigation_link': 'Redundancy@odata.navigationLink',
            'related_item': 'RelatedItem',
            'related_itemodata_count': 'RelatedItem@odata.count',
            'related_itemodata_navigation_link': 'RelatedItem@odata.navigationLink',
            'serial_number': 'SerialNumber',
            'spare_part_number': 'SparePartNumber',
            'status': 'Status'
        }

        self._firmware_version = None
        self._last_power_output_watts = None
        self._line_input_voltage = None
        self._line_input_voltage_type = None
        self._member_id = None
        self._model = None
        self._name = None
        self._oem = None
        self._part_number = None
        self._power_capacity_watts = None
        self._power_supply_type = None
        self._redundancy = None
        self._redundancyodata_count = None
        self._redundancyodata_navigation_link = None
        self._related_item = None
        self._related_itemodata_count = None
        self._related_itemodata_navigation_link = None
        self._serial_number = None
        self._spare_part_number = None
        self._status = None

    @property
    def firmware_version(self):
        """
        Gets the firmware_version of this Power100PowerSupply.
        The firmware version for this Power Supply

        :return: The firmware_version of this Power100PowerSupply.
        :rtype: str
        """
        return self._firmware_version

    @firmware_version.setter
    def firmware_version(self, firmware_version):
        """
        Sets the firmware_version of this Power100PowerSupply.
        The firmware version for this Power Supply

        :param firmware_version: The firmware_version of this Power100PowerSupply.
        :type: str
        """
        self._firmware_version = firmware_version

    @property
    def last_power_output_watts(self):
        """
        Gets the last_power_output_watts of this Power100PowerSupply.
        The average power output of this Power Supply

        :return: The last_power_output_watts of this Power100PowerSupply.
        :rtype: float
        """
        return self._last_power_output_watts

    @last_power_output_watts.setter
    def last_power_output_watts(self, last_power_output_watts):
        """
        Sets the last_power_output_watts of this Power100PowerSupply.
        The average power output of this Power Supply

        :param last_power_output_watts: The last_power_output_watts of this Power100PowerSupply.
        :type: float
        """
        self._last_power_output_watts = last_power_output_watts

    @property
    def line_input_voltage(self):
        """
        Gets the line_input_voltage of this Power100PowerSupply.
        The line input voltage at which the Power Supply is operating

        :return: The line_input_voltage of this Power100PowerSupply.
        :rtype: float
        """
        return self._line_input_voltage

    @line_input_voltage.setter
    def line_input_voltage(self, line_input_voltage):
        """
        Sets the line_input_voltage of this Power100PowerSupply.
        The line input voltage at which the Power Supply is operating

        :param line_input_voltage: The line_input_voltage of this Power100PowerSupply.
        :type: float
        """
        self._line_input_voltage = line_input_voltage

    @property
    def line_input_voltage_type(self):
        """
        Gets the line_input_voltage_type of this Power100PowerSupply.
        The line voltage type supported as an input to this Power Supply

        :return: The line_input_voltage_type of this Power100PowerSupply.
        :rtype: str
        """
        return self._line_input_voltage_type

    @line_input_voltage_type.setter
    def line_input_voltage_type(self, line_input_voltage_type):
        """
        Sets the line_input_voltage_type of this Power100PowerSupply.
        The line voltage type supported as an input to this Power Supply

        :param line_input_voltage_type: The line_input_voltage_type of this Power100PowerSupply.
        :type: str
        """
        allowed_values = ["Unknown", "ACLowLine", "ACMidLine", "ACHighLine", "DCNeg48V", "DC480V"]
        if line_input_voltage_type not in allowed_values:
            raise ValueError(
                "Invalid value for `line_input_voltage_type`, must be one of {0}"
                .format(allowed_values)
            )
        self._line_input_voltage_type = line_input_voltage_type

    @property
    def member_id(self):
        """
        Gets the member_id of this Power100PowerSupply.
        This is the identifier for the member within the collection.

        :return: The member_id of this Power100PowerSupply.
        :rtype: str
        """
        return self._member_id

    @member_id.setter
    def member_id(self, member_id):
        """
        Sets the member_id of this Power100PowerSupply.
        This is the identifier for the member within the collection.

        :param member_id: The member_id of this Power100PowerSupply.
        :type: str
        """
        self._member_id = member_id

    @property
    def model(self):
        """
        Gets the model of this Power100PowerSupply.
        The model number for this Power Supply

        :return: The model of this Power100PowerSupply.
        :rtype: str
        """
        return self._model

    @model.setter
    def model(self, model):
        """
        Sets the model of this Power100PowerSupply.
        The model number for this Power Supply

        :param model: The model of this Power100PowerSupply.
        :type: str
        """
        self._model = model

    @property
    def name(self):
        """
        Gets the name of this Power100PowerSupply.
        The name of the Power Supply

        :return: The name of this Power100PowerSupply.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """
        Sets the name of this Power100PowerSupply.
        The name of the Power Supply

        :param name: The name of this Power100PowerSupply.
        :type: str
        """
        self._name = name

    @property
    def oem(self):
        """
        Gets the oem of this Power100PowerSupply.
        This is the manufacturer/provider specific extension moniker used to divide the Oem object into sections.

        :return: The oem of this Power100PowerSupply.
        :rtype: ResourceOem
        """
        return self._oem

    @oem.setter
    def oem(self, oem):
        """
        Sets the oem of this Power100PowerSupply.
        This is the manufacturer/provider specific extension moniker used to divide the Oem object into sections.

        :param oem: The oem of this Power100PowerSupply.
        :type: ResourceOem
        """
        self._oem = oem

    @property
    def part_number(self):
        """
        Gets the part_number of this Power100PowerSupply.
        The part number for this Power Supply

        :return: The part_number of this Power100PowerSupply.
        :rtype: str
        """
        return self._part_number

    @part_number.setter
    def part_number(self, part_number):
        """
        Sets the part_number of this Power100PowerSupply.
        The part number for this Power Supply

        :param part_number: The part_number of this Power100PowerSupply.
        :type: str
        """
        self._part_number = part_number

    @property
    def power_capacity_watts(self):
        """
        Gets the power_capacity_watts of this Power100PowerSupply.
        The maximum capacity of this Power Supply

        :return: The power_capacity_watts of this Power100PowerSupply.
        :rtype: float
        """
        return self._power_capacity_watts

    @power_capacity_watts.setter
    def power_capacity_watts(self, power_capacity_watts):
        """
        Sets the power_capacity_watts of this Power100PowerSupply.
        The maximum capacity of this Power Supply

        :param power_capacity_watts: The power_capacity_watts of this Power100PowerSupply.
        :type: float
        """
        self._power_capacity_watts = power_capacity_watts

    @property
    def power_supply_type(self):
        """
        Gets the power_supply_type of this Power100PowerSupply.
        The Power Supply type (AC or DC)

        :return: The power_supply_type of this Power100PowerSupply.
        :rtype: str
        """
        return self._power_supply_type

    @power_supply_type.setter
    def power_supply_type(self, power_supply_type):
        """
        Sets the power_supply_type of this Power100PowerSupply.
        The Power Supply type (AC or DC)

        :param power_supply_type: The power_supply_type of this Power100PowerSupply.
        :type: str
        """
        allowed_values = ["Unknown", "AC", "DC"]
        if power_supply_type not in allowed_values:
            raise ValueError(
                "Invalid value for `power_supply_type`, must be one of {0}"
                .format(allowed_values)
            )
        self._power_supply_type = power_supply_type

    @property
    def redundancy(self):
        """
        Gets the redundancy of this Power100PowerSupply.
        This structure is used to show redundancy for fans.  The Component ids will reference the members of the redundancy groups.

        :return: The redundancy of this Power100PowerSupply.
        :rtype: list[Odata400IdRef]
        """
        return self._redundancy

    @redundancy.setter
    def redundancy(self, redundancy):
        """
        Sets the redundancy of this Power100PowerSupply.
        This structure is used to show redundancy for fans.  The Component ids will reference the members of the redundancy groups.

        :param redundancy: The redundancy of this Power100PowerSupply.
        :type: list[Odata400IdRef]
        """
        self._redundancy = redundancy

    @property
    def redundancyodata_count(self):
        """
        Gets the redundancyodata_count of this Power100PowerSupply.


        :return: The redundancyodata_count of this Power100PowerSupply.
        :rtype: float
        """
        return self._redundancyodata_count

    @redundancyodata_count.setter
    def redundancyodata_count(self, redundancyodata_count):
        """
        Sets the redundancyodata_count of this Power100PowerSupply.


        :param redundancyodata_count: The redundancyodata_count of this Power100PowerSupply.
        :type: float
        """
        self._redundancyodata_count = redundancyodata_count

    @property
    def redundancyodata_navigation_link(self):
        """
        Gets the redundancyodata_navigation_link of this Power100PowerSupply.


        :return: The redundancyodata_navigation_link of this Power100PowerSupply.
        :rtype: Odata400IdRef
        """
        return self._redundancyodata_navigation_link

    @redundancyodata_navigation_link.setter
    def redundancyodata_navigation_link(self, redundancyodata_navigation_link):
        """
        Sets the redundancyodata_navigation_link of this Power100PowerSupply.


        :param redundancyodata_navigation_link: The redundancyodata_navigation_link of this Power100PowerSupply.
        :type: Odata400IdRef
        """
        self._redundancyodata_navigation_link = redundancyodata_navigation_link

    @property
    def related_item(self):
        """
        Gets the related_item of this Power100PowerSupply.
        The ID(s) of the resources associated with this Power Limit

        :return: The related_item of this Power100PowerSupply.
        :rtype: list[Odata400IdRef]
        """
        return self._related_item

    @related_item.setter
    def related_item(self, related_item):
        """
        Sets the related_item of this Power100PowerSupply.
        The ID(s) of the resources associated with this Power Limit

        :param related_item: The related_item of this Power100PowerSupply.
        :type: list[Odata400IdRef]
        """
        self._related_item = related_item

    @property
    def related_itemodata_count(self):
        """
        Gets the related_itemodata_count of this Power100PowerSupply.


        :return: The related_itemodata_count of this Power100PowerSupply.
        :rtype: float
        """
        return self._related_itemodata_count

    @related_itemodata_count.setter
    def related_itemodata_count(self, related_itemodata_count):
        """
        Sets the related_itemodata_count of this Power100PowerSupply.


        :param related_itemodata_count: The related_itemodata_count of this Power100PowerSupply.
        :type: float
        """
        self._related_itemodata_count = related_itemodata_count

    @property
    def related_itemodata_navigation_link(self):
        """
        Gets the related_itemodata_navigation_link of this Power100PowerSupply.


        :return: The related_itemodata_navigation_link of this Power100PowerSupply.
        :rtype: Odata400IdRef
        """
        return self._related_itemodata_navigation_link

    @related_itemodata_navigation_link.setter
    def related_itemodata_navigation_link(self, related_itemodata_navigation_link):
        """
        Sets the related_itemodata_navigation_link of this Power100PowerSupply.


        :param related_itemodata_navigation_link: The related_itemodata_navigation_link of this Power100PowerSupply.
        :type: Odata400IdRef
        """
        self._related_itemodata_navigation_link = related_itemodata_navigation_link

    @property
    def serial_number(self):
        """
        Gets the serial_number of this Power100PowerSupply.
        The serial number for this Power Supply

        :return: The serial_number of this Power100PowerSupply.
        :rtype: str
        """
        return self._serial_number

    @serial_number.setter
    def serial_number(self, serial_number):
        """
        Sets the serial_number of this Power100PowerSupply.
        The serial number for this Power Supply

        :param serial_number: The serial_number of this Power100PowerSupply.
        :type: str
        """
        self._serial_number = serial_number

    @property
    def spare_part_number(self):
        """
        Gets the spare_part_number of this Power100PowerSupply.
        The spare part number for this Power Supply

        :return: The spare_part_number of this Power100PowerSupply.
        :rtype: str
        """
        return self._spare_part_number

    @spare_part_number.setter
    def spare_part_number(self, spare_part_number):
        """
        Sets the spare_part_number of this Power100PowerSupply.
        The spare part number for this Power Supply

        :param spare_part_number: The spare_part_number of this Power100PowerSupply.
        :type: str
        """
        self._spare_part_number = spare_part_number

    @property
    def status(self):
        """
        Gets the status of this Power100PowerSupply.


        :return: The status of this Power100PowerSupply.
        :rtype: ResourceStatus
        """
        return self._status

    @status.setter
    def status(self, status):
        """
        Sets the status of this Power100PowerSupply.


        :param status: The status of this Power100PowerSupply.
        :type: ResourceStatus
        """
        self._status = status

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other): 
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """ 
        Returns true if both objects are not equal
        """
        return not self == other

