# coding: utf-8

"""
Copyright 2015 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from pprint import pformat
from six import iteritems


class Role100Role(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        Role100Role - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'odata_context': 'str',
            'odata_id': 'str',
            'odata_type': 'str',
            'assigned_privileges': 'list[str]',
            'description': 'str',
            'id': 'str',
            'is_predefined': 'bool',
            'name': 'str',
            'oem': 'ResourceOem',
            'oem_privileges': 'list[str]'
        }

        self.attribute_map = {
            'odata_context': '@odata.context',
            'odata_id': '@odata.id',
            'odata_type': '@odata.type',
            'assigned_privileges': 'AssignedPrivileges',
            'description': 'Description',
            'id': 'Id',
            'is_predefined': 'IsPredefined',
            'name': 'Name',
            'oem': 'Oem',
            'oem_privileges': 'OemPrivileges'
        }

        self._odata_context = None
        self._odata_id = None
        self._odata_type = None
        self._assigned_privileges = None
        self._description = None
        self._id = None
        self._is_predefined = None
        self._name = None
        self._oem = None
        self._oem_privileges = None

    @property
    def odata_context(self):
        """
        Gets the odata_context of this Role100Role.


        :return: The odata_context of this Role100Role.
        :rtype: str
        """
        return self._odata_context

    @odata_context.setter
    def odata_context(self, odata_context):
        """
        Sets the odata_context of this Role100Role.


        :param odata_context: The odata_context of this Role100Role.
        :type: str
        """
        self._odata_context = odata_context

    @property
    def odata_id(self):
        """
        Gets the odata_id of this Role100Role.


        :return: The odata_id of this Role100Role.
        :rtype: str
        """
        return self._odata_id

    @odata_id.setter
    def odata_id(self, odata_id):
        """
        Sets the odata_id of this Role100Role.


        :param odata_id: The odata_id of this Role100Role.
        :type: str
        """
        self._odata_id = odata_id

    @property
    def odata_type(self):
        """
        Gets the odata_type of this Role100Role.


        :return: The odata_type of this Role100Role.
        :rtype: str
        """
        return self._odata_type

    @odata_type.setter
    def odata_type(self, odata_type):
        """
        Sets the odata_type of this Role100Role.


        :param odata_type: The odata_type of this Role100Role.
        :type: str
        """
        self._odata_type = odata_type

    @property
    def assigned_privileges(self):
        """
        Gets the assigned_privileges of this Role100Role.
        The redfish privileges that this role includes.

        :return: The assigned_privileges of this Role100Role.
        :rtype: list[str]
        """
        return self._assigned_privileges

    @assigned_privileges.setter
    def assigned_privileges(self, assigned_privileges):
        """
        Sets the assigned_privileges of this Role100Role.
        The redfish privileges that this role includes.

        :param assigned_privileges: The assigned_privileges of this Role100Role.
        :type: list[str]
        """
        self._assigned_privileges = assigned_privileges

    @property
    def description(self):
        """
        Gets the description of this Role100Role.
        Provides a description of this resource and is used for commonality  in the schema definitions.

        :return: The description of this Role100Role.
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """
        Sets the description of this Role100Role.
        Provides a description of this resource and is used for commonality  in the schema definitions.

        :param description: The description of this Role100Role.
        :type: str
        """
        self._description = description

    @property
    def id(self):
        """
        Gets the id of this Role100Role.
        Uniquely identifies the resource within the collection of like resources.

        :return: The id of this Role100Role.
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """
        Sets the id of this Role100Role.
        Uniquely identifies the resource within the collection of like resources.

        :param id: The id of this Role100Role.
        :type: str
        """
        self._id = id

    @property
    def is_predefined(self):
        """
        Gets the is_predefined of this Role100Role.
        This property is used to indicate if the Role is one of the Redfish Predefined Roles vs a Custom role.

        :return: The is_predefined of this Role100Role.
        :rtype: bool
        """
        return self._is_predefined

    @is_predefined.setter
    def is_predefined(self, is_predefined):
        """
        Sets the is_predefined of this Role100Role.
        This property is used to indicate if the Role is one of the Redfish Predefined Roles vs a Custom role.

        :param is_predefined: The is_predefined of this Role100Role.
        :type: bool
        """
        self._is_predefined = is_predefined

    @property
    def name(self):
        """
        Gets the name of this Role100Role.
        The name of the resource or array element.

        :return: The name of this Role100Role.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """
        Sets the name of this Role100Role.
        The name of the resource or array element.

        :param name: The name of this Role100Role.
        :type: str
        """
        self._name = name

    @property
    def oem(self):
        """
        Gets the oem of this Role100Role.
        This is the manufacturer/provider specific extension moniker used to divide the Oem object into sections.

        :return: The oem of this Role100Role.
        :rtype: ResourceOem
        """
        return self._oem

    @oem.setter
    def oem(self, oem):
        """
        Sets the oem of this Role100Role.
        This is the manufacturer/provider specific extension moniker used to divide the Oem object into sections.

        :param oem: The oem of this Role100Role.
        :type: ResourceOem
        """
        self._oem = oem

    @property
    def oem_privileges(self):
        """
        Gets the oem_privileges of this Role100Role.
        The OEM privileges that this role includes.

        :return: The oem_privileges of this Role100Role.
        :rtype: list[str]
        """
        return self._oem_privileges

    @oem_privileges.setter
    def oem_privileges(self, oem_privileges):
        """
        Sets the oem_privileges of this Role100Role.
        The OEM privileges that this role includes.

        :param oem_privileges: The oem_privileges of this Role100Role.
        :type: list[str]
        """
        self._oem_privileges = oem_privileges

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other): 
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """ 
        Returns true if both objects are not equal
        """
        return not self == other

