# coding: utf-8

"""
Copyright 2015 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from pprint import pformat
from six import iteritems


class SimpleStorage100Device(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        SimpleStorage100Device - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'manufacturer': 'str',
            'model': 'str',
            'name': 'str',
            'oem': 'ResourceOem',
            'status': 'ResourceStatus'
        }

        self.attribute_map = {
            'manufacturer': 'Manufacturer',
            'model': 'Model',
            'name': 'Name',
            'oem': 'Oem',
            'status': 'Status'
        }

        self._manufacturer = None
        self._model = None
        self._name = None
        self._oem = None
        self._status = None

    @property
    def manufacturer(self):
        """
        Gets the manufacturer of this SimpleStorage100Device.
        The name of the manufacturer of this device

        :return: The manufacturer of this SimpleStorage100Device.
        :rtype: str
        """
        return self._manufacturer

    @manufacturer.setter
    def manufacturer(self, manufacturer):
        """
        Sets the manufacturer of this SimpleStorage100Device.
        The name of the manufacturer of this device

        :param manufacturer: The manufacturer of this SimpleStorage100Device.
        :type: str
        """
        self._manufacturer = manufacturer

    @property
    def model(self):
        """
        Gets the model of this SimpleStorage100Device.
        The product model number of this device

        :return: The model of this SimpleStorage100Device.
        :rtype: str
        """
        return self._model

    @model.setter
    def model(self, model):
        """
        Sets the model of this SimpleStorage100Device.
        The product model number of this device

        :param model: The model of this SimpleStorage100Device.
        :type: str
        """
        self._model = model

    @property
    def name(self):
        """
        Gets the name of this SimpleStorage100Device.
        The name of the resource or array element.

        :return: The name of this SimpleStorage100Device.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """
        Sets the name of this SimpleStorage100Device.
        The name of the resource or array element.

        :param name: The name of this SimpleStorage100Device.
        :type: str
        """
        self._name = name

    @property
    def oem(self):
        """
        Gets the oem of this SimpleStorage100Device.


        :return: The oem of this SimpleStorage100Device.
        :rtype: ResourceOem
        """
        return self._oem

    @oem.setter
    def oem(self, oem):
        """
        Sets the oem of this SimpleStorage100Device.


        :param oem: The oem of this SimpleStorage100Device.
        :type: ResourceOem
        """
        self._oem = oem

    @property
    def status(self):
        """
        Gets the status of this SimpleStorage100Device.


        :return: The status of this SimpleStorage100Device.
        :rtype: ResourceStatus
        """
        return self._status

    @status.setter
    def status(self, status):
        """
        Sets the status of this SimpleStorage100Device.


        :param status: The status of this SimpleStorage100Device.
        :type: ResourceStatus
        """
        self._status = status

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other): 
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """ 
        Returns true if both objects are not equal
        """
        return not self == other

