# coding: utf-8

"""
Copyright 2015 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from pprint import pformat
from six import iteritems


class UpdateServiceV110UpdateService(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        UpdateServiceV110UpdateService - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'odata_context': 'str',
            'odata_id': 'str',
            'odata_type': 'str',
            'actions': 'UpdateServiceV110UpdateServiceActions',
            'description': 'object',
            'firmware_inventory': 'SoftwareInventoryCollectionSoftwareInventoryCollection',
            'http_push_uri': 'str',
            'id': 'str',
            'name': 'str',
            'oem': 'ResourceOem',
            'service_enabled': 'bool',
            'software_inventory': 'SoftwareInventoryCollectionSoftwareInventoryCollection',
            'status': 'ResourceStatus'
        }

        self.attribute_map = {
            'odata_context': '@odata.context',
            'odata_id': '@odata.id',
            'odata_type': '@odata.type',
            'actions': 'Actions',
            'description': 'Description',
            'firmware_inventory': 'FirmwareInventory',
            'http_push_uri': 'HttpPushUri',
            'id': 'Id',
            'name': 'Name',
            'oem': 'Oem',
            'service_enabled': 'ServiceEnabled',
            'software_inventory': 'SoftwareInventory',
            'status': 'Status'
        }

        self._odata_context = None
        self._odata_id = None
        self._odata_type = None
        self._actions = None
        self._description = None
        self._firmware_inventory = None
        self._http_push_uri = None
        self._id = None
        self._name = None
        self._oem = None
        self._service_enabled = None
        self._software_inventory = None
        self._status = None

    @property
    def odata_context(self):
        """
        Gets the odata_context of this UpdateServiceV110UpdateService.


        :return: The odata_context of this UpdateServiceV110UpdateService.
        :rtype: str
        """
        return self._odata_context

    @odata_context.setter
    def odata_context(self, odata_context):
        """
        Sets the odata_context of this UpdateServiceV110UpdateService.


        :param odata_context: The odata_context of this UpdateServiceV110UpdateService.
        :type: str
        """
        self._odata_context = odata_context

    @property
    def odata_id(self):
        """
        Gets the odata_id of this UpdateServiceV110UpdateService.


        :return: The odata_id of this UpdateServiceV110UpdateService.
        :rtype: str
        """
        return self._odata_id

    @odata_id.setter
    def odata_id(self, odata_id):
        """
        Sets the odata_id of this UpdateServiceV110UpdateService.


        :param odata_id: The odata_id of this UpdateServiceV110UpdateService.
        :type: str
        """
        self._odata_id = odata_id

    @property
    def odata_type(self):
        """
        Gets the odata_type of this UpdateServiceV110UpdateService.


        :return: The odata_type of this UpdateServiceV110UpdateService.
        :rtype: str
        """
        return self._odata_type

    @odata_type.setter
    def odata_type(self, odata_type):
        """
        Sets the odata_type of this UpdateServiceV110UpdateService.


        :param odata_type: The odata_type of this UpdateServiceV110UpdateService.
        :type: str
        """
        self._odata_type = odata_type

    @property
    def actions(self):
        """
        Gets the actions of this UpdateServiceV110UpdateService.


        :return: The actions of this UpdateServiceV110UpdateService.
        :rtype: UpdateServiceV110UpdateServiceActions
        """
        return self._actions

    @actions.setter
    def actions(self, actions):
        """
        Sets the actions of this UpdateServiceV110UpdateService.


        :param actions: The actions of this UpdateServiceV110UpdateService.
        :type: UpdateServiceV110UpdateServiceActions
        """
        self._actions = actions

    @property
    def description(self):
        """
        Gets the description of this UpdateServiceV110UpdateService.
        Provides a description of this resource and is used for commonality in the schema definitions.

        :return: The description of this UpdateServiceV110UpdateService.
        :rtype: object
        """
        return self._description

    @description.setter
    def description(self, description):
        """
        Sets the description of this UpdateServiceV110UpdateService.
        Provides a description of this resource and is used for commonality in the schema definitions.

        :param description: The description of this UpdateServiceV110UpdateService.
        :type: object
        """
        self._description = description

    @property
    def firmware_inventory(self):
        """
        Gets the firmware_inventory of this UpdateServiceV110UpdateService.
        An inventory of firmware.

        :return: The firmware_inventory of this UpdateServiceV110UpdateService.
        :rtype: SoftwareInventoryCollectionSoftwareInventoryCollection
        """
        return self._firmware_inventory

    @firmware_inventory.setter
    def firmware_inventory(self, firmware_inventory):
        """
        Sets the firmware_inventory of this UpdateServiceV110UpdateService.
        An inventory of firmware.

        :param firmware_inventory: The firmware_inventory of this UpdateServiceV110UpdateService.
        :type: SoftwareInventoryCollectionSoftwareInventoryCollection
        """
        self._firmware_inventory = firmware_inventory

    @property
    def http_push_uri(self):
        """
        Gets the http_push_uri of this UpdateServiceV110UpdateService.
        The URI used to perform an HTTP or HTTPS push update to the Update Service.

        :return: The http_push_uri of this UpdateServiceV110UpdateService.
        :rtype: str
        """
        return self._http_push_uri

    @http_push_uri.setter
    def http_push_uri(self, http_push_uri):
        """
        Sets the http_push_uri of this UpdateServiceV110UpdateService.
        The URI used to perform an HTTP or HTTPS push update to the Update Service.

        :param http_push_uri: The http_push_uri of this UpdateServiceV110UpdateService.
        :type: str
        """
        self._http_push_uri = http_push_uri

    @property
    def id(self):
        """
        Gets the id of this UpdateServiceV110UpdateService.
        Uniquely identifies the resource within the collection of like resources.

        :return: The id of this UpdateServiceV110UpdateService.
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """
        Sets the id of this UpdateServiceV110UpdateService.
        Uniquely identifies the resource within the collection of like resources.

        :param id: The id of this UpdateServiceV110UpdateService.
        :type: str
        """
        self._id = id

    @property
    def name(self):
        """
        Gets the name of this UpdateServiceV110UpdateService.
        The name of the resource or array element.

        :return: The name of this UpdateServiceV110UpdateService.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """
        Sets the name of this UpdateServiceV110UpdateService.
        The name of the resource or array element.

        :param name: The name of this UpdateServiceV110UpdateService.
        :type: str
        """
        self._name = name

    @property
    def oem(self):
        """
        Gets the oem of this UpdateServiceV110UpdateService.
        This is the manufacturer/provider specific extension moniker used to divide the Oem object into sections.

        :return: The oem of this UpdateServiceV110UpdateService.
        :rtype: ResourceOem
        """
        return self._oem

    @oem.setter
    def oem(self, oem):
        """
        Sets the oem of this UpdateServiceV110UpdateService.
        This is the manufacturer/provider specific extension moniker used to divide the Oem object into sections.

        :param oem: The oem of this UpdateServiceV110UpdateService.
        :type: ResourceOem
        """
        self._oem = oem

    @property
    def service_enabled(self):
        """
        Gets the service_enabled of this UpdateServiceV110UpdateService.
        This indicates whether this service is enabled.

        :return: The service_enabled of this UpdateServiceV110UpdateService.
        :rtype: bool
        """
        return self._service_enabled

    @service_enabled.setter
    def service_enabled(self, service_enabled):
        """
        Sets the service_enabled of this UpdateServiceV110UpdateService.
        This indicates whether this service is enabled.

        :param service_enabled: The service_enabled of this UpdateServiceV110UpdateService.
        :type: bool
        """
        self._service_enabled = service_enabled

    @property
    def software_inventory(self):
        """
        Gets the software_inventory of this UpdateServiceV110UpdateService.
        An inventory of software.

        :return: The software_inventory of this UpdateServiceV110UpdateService.
        :rtype: SoftwareInventoryCollectionSoftwareInventoryCollection
        """
        return self._software_inventory

    @software_inventory.setter
    def software_inventory(self, software_inventory):
        """
        Sets the software_inventory of this UpdateServiceV110UpdateService.
        An inventory of software.

        :param software_inventory: The software_inventory of this UpdateServiceV110UpdateService.
        :type: SoftwareInventoryCollectionSoftwareInventoryCollection
        """
        self._software_inventory = software_inventory

    @property
    def status(self):
        """
        Gets the status of this UpdateServiceV110UpdateService.


        :return: The status of this UpdateServiceV110UpdateService.
        :rtype: ResourceStatus
        """
        return self._status

    @status.setter
    def status(self, status):
        """
        Sets the status of this UpdateServiceV110UpdateService.


        :param status: The status of this UpdateServiceV110UpdateService.
        :type: ResourceStatus
        """
        self._status = status

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other): 
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """ 
        Returns true if both objects are not equal
        """
        return not self == other

