# coding: utf-8

"""
Copyright 2015 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from pprint import pformat
from six import iteritems


class UpdateServiceV110UpdateServicePost(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        UpdateServiceV110UpdateServicePost - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'image_uri': 'str',
            'targets': 'list[str]'
        }

        self.attribute_map = {
            'image_uri': 'ImageURI',
            'targets': 'Targets'
        }

        self._image_uri = None
        self._targets = None

    @property
    def image_uri(self):
        """
        Gets the image_uri of this UpdateServiceV110UpdateServicePost.
        The URI of the firmware update package.

        :return: The image_uri of this UpdateServiceV110UpdateServicePost.
        :rtype: str
        """
        return self._image_uri

    @image_uri.setter
    def image_uri(self, image_uri):
        """
        Sets the image_uri of this UpdateServiceV110UpdateServicePost.
        The URI of the firmware update package.

        :param image_uri: The image_uri of this UpdateServiceV110UpdateServicePost.
        :type: str
        """
        self._image_uri = image_uri

    @property
    def targets(self):
        """
        Gets the targets of this UpdateServiceV110UpdateServicePost.
        The identifiers of the nodes on which to perform the firmware update.

        :return: The targets of this UpdateServiceV110UpdateServicePost.
        :rtype: list[str]
        """
        return self._targets

    @targets.setter
    def targets(self, targets):
        """
        Sets the targets of this UpdateServiceV110UpdateServicePost.
        The identifiers of the nodes on which to perform the firmware update.

        :param targets: The targets of this UpdateServiceV110UpdateServicePost.
        :type: list[str]
        """
        self._targets = targets

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other): 
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """ 
        Returns true if both objects are not equal
        """
        return not self == other

