# coding: utf-8

"""
Copyright 2015 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from pprint import pformat
from six import iteritems


class VLanNetworkInterfaceCollectionVLanNetworkInterfaceCollection(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        VLanNetworkInterfaceCollectionVLanNetworkInterfaceCollection - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'description': 'str',
            'members': 'list[VLanNetworkInterfaceVLanNetworkInterface]',
            'membersodata_count': 'float',
            'membersodata_navigation_link': 'Odata400IdRef',
            'name': 'str',
            'oem': 'ResourceOem'
        }

        self.attribute_map = {
            'description': 'Description',
            'members': 'Members',
            'membersodata_count': 'Members@odata.count',
            'membersodata_navigation_link': 'Members@odata.navigationLink',
            'name': 'Name',
            'oem': 'Oem'
        }

        self._description = None
        self._members = None
        self._membersodata_count = None
        self._membersodata_navigation_link = None
        self._name = None
        self._oem = None

    @property
    def description(self):
        """
        Gets the description of this VLanNetworkInterfaceCollectionVLanNetworkInterfaceCollection.
        Uniquely identifies the resource within the collection of like resources.

        :return: The description of this VLanNetworkInterfaceCollectionVLanNetworkInterfaceCollection.
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """
        Sets the description of this VLanNetworkInterfaceCollectionVLanNetworkInterfaceCollection.
        Uniquely identifies the resource within the collection of like resources.

        :param description: The description of this VLanNetworkInterfaceCollectionVLanNetworkInterfaceCollection.
        :type: str
        """
        self._description = description

    @property
    def members(self):
        """
        Gets the members of this VLanNetworkInterfaceCollectionVLanNetworkInterfaceCollection.
        Contains the members of this collection.

        :return: The members of this VLanNetworkInterfaceCollectionVLanNetworkInterfaceCollection.
        :rtype: list[VLanNetworkInterfaceVLanNetworkInterface]
        """
        return self._members

    @members.setter
    def members(self, members):
        """
        Sets the members of this VLanNetworkInterfaceCollectionVLanNetworkInterfaceCollection.
        Contains the members of this collection.

        :param members: The members of this VLanNetworkInterfaceCollectionVLanNetworkInterfaceCollection.
        :type: list[VLanNetworkInterfaceVLanNetworkInterface]
        """
        self._members = members

    @property
    def membersodata_count(self):
        """
        Gets the membersodata_count of this VLanNetworkInterfaceCollectionVLanNetworkInterfaceCollection.


        :return: The membersodata_count of this VLanNetworkInterfaceCollectionVLanNetworkInterfaceCollection.
        :rtype: float
        """
        return self._membersodata_count

    @membersodata_count.setter
    def membersodata_count(self, membersodata_count):
        """
        Sets the membersodata_count of this VLanNetworkInterfaceCollectionVLanNetworkInterfaceCollection.


        :param membersodata_count: The membersodata_count of this VLanNetworkInterfaceCollectionVLanNetworkInterfaceCollection.
        :type: float
        """
        self._membersodata_count = membersodata_count

    @property
    def membersodata_navigation_link(self):
        """
        Gets the membersodata_navigation_link of this VLanNetworkInterfaceCollectionVLanNetworkInterfaceCollection.


        :return: The membersodata_navigation_link of this VLanNetworkInterfaceCollectionVLanNetworkInterfaceCollection.
        :rtype: Odata400IdRef
        """
        return self._membersodata_navigation_link

    @membersodata_navigation_link.setter
    def membersodata_navigation_link(self, membersodata_navigation_link):
        """
        Sets the membersodata_navigation_link of this VLanNetworkInterfaceCollectionVLanNetworkInterfaceCollection.


        :param membersodata_navigation_link: The membersodata_navigation_link of this VLanNetworkInterfaceCollectionVLanNetworkInterfaceCollection.
        :type: Odata400IdRef
        """
        self._membersodata_navigation_link = membersodata_navigation_link

    @property
    def name(self):
        """
        Gets the name of this VLanNetworkInterfaceCollectionVLanNetworkInterfaceCollection.
        The name of the resource or array element.

        :return: The name of this VLanNetworkInterfaceCollectionVLanNetworkInterfaceCollection.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """
        Sets the name of this VLanNetworkInterfaceCollectionVLanNetworkInterfaceCollection.
        The name of the resource or array element.

        :param name: The name of this VLanNetworkInterfaceCollectionVLanNetworkInterfaceCollection.
        :type: str
        """
        self._name = name

    @property
    def oem(self):
        """
        Gets the oem of this VLanNetworkInterfaceCollectionVLanNetworkInterfaceCollection.
        This is the manufacturer/provider specific extension moniker used to divide the Oem object into sections.

        :return: The oem of this VLanNetworkInterfaceCollectionVLanNetworkInterfaceCollection.
        :rtype: ResourceOem
        """
        return self._oem

    @oem.setter
    def oem(self, oem):
        """
        Sets the oem of this VLanNetworkInterfaceCollectionVLanNetworkInterfaceCollection.
        This is the manufacturer/provider specific extension moniker used to divide the Oem object into sections.

        :param oem: The oem of this VLanNetworkInterfaceCollectionVLanNetworkInterfaceCollection.
        :type: ResourceOem
        """
        self._oem = oem

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other): 
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """ 
        Returns true if both objects are not equal
        """
        return not self == other

