# coding: utf-8

"""
Copyright 2015 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from pprint import pformat
from six import iteritems


class VLanNetworkInterfaceV100VLAN(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        VLanNetworkInterfaceV100VLAN - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'vlan_enable': 'bool',
            'vlan_id': 'VLanNetworkInterfaceV100VLANId'
        }

        self.attribute_map = {
            'vlan_enable': 'VLANEnable',
            'vlan_id': 'VLANId'
        }

        self._vlan_enable = None
        self._vlan_id = None

    @property
    def vlan_enable(self):
        """
        Gets the vlan_enable of this VLanNetworkInterfaceV100VLAN.
        This indicates if this VLAN is enabled.

        :return: The vlan_enable of this VLanNetworkInterfaceV100VLAN.
        :rtype: bool
        """
        return self._vlan_enable

    @vlan_enable.setter
    def vlan_enable(self, vlan_enable):
        """
        Sets the vlan_enable of this VLanNetworkInterfaceV100VLAN.
        This indicates if this VLAN is enabled.

        :param vlan_enable: The vlan_enable of this VLanNetworkInterfaceV100VLAN.
        :type: bool
        """
        self._vlan_enable = vlan_enable

    @property
    def vlan_id(self):
        """
        Gets the vlan_id of this VLanNetworkInterfaceV100VLAN.
        This indicates the VLAN identifier for this VLAN.

        :return: The vlan_id of this VLanNetworkInterfaceV100VLAN.
        :rtype: VLanNetworkInterfaceV100VLANId
        """
        return self._vlan_id

    @vlan_id.setter
    def vlan_id(self, vlan_id):
        """
        Sets the vlan_id of this VLanNetworkInterfaceV100VLAN.
        This indicates the VLAN identifier for this VLAN.

        :param vlan_id: The vlan_id of this VLanNetworkInterfaceV100VLAN.
        :type: VLanNetworkInterfaceV100VLANId
        """
        self._vlan_id = vlan_id

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other): 
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """ 
        Returns true if both objects are not equal
        """
        return not self == other

