# coding: utf-8

"""
Copyright 2015 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from pprint import pformat
from six import iteritems


class VirtualMedia100VirtualMedia(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        VirtualMedia100VirtualMedia - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'odata_context': 'str',
            'odata_id': 'str',
            'odata_type': 'str',
            'connected_via': 'str',
            'description': 'str',
            'id': 'str',
            'image': 'str',
            'image_name': 'str',
            'inserted': 'bool',
            'media_types': 'list[str]',
            'name': 'str',
            'oem': 'ResourceOem',
            'write_protected': 'bool'
        }

        self.attribute_map = {
            'odata_context': '@odata.context',
            'odata_id': '@odata.id',
            'odata_type': '@odata.type',
            'connected_via': 'ConnectedVia',
            'description': 'Description',
            'id': 'Id',
            'image': 'Image',
            'image_name': 'ImageName',
            'inserted': 'Inserted',
            'media_types': 'MediaTypes',
            'name': 'Name',
            'oem': 'Oem',
            'write_protected': 'WriteProtected'
        }

        self._odata_context = None
        self._odata_id = None
        self._odata_type = None
        self._connected_via = None
        self._description = None
        self._id = None
        self._image = None
        self._image_name = None
        self._inserted = None
        self._media_types = None
        self._name = None
        self._oem = None
        self._write_protected = None

    @property
    def odata_context(self):
        """
        Gets the odata_context of this VirtualMedia100VirtualMedia.


        :return: The odata_context of this VirtualMedia100VirtualMedia.
        :rtype: str
        """
        return self._odata_context

    @odata_context.setter
    def odata_context(self, odata_context):
        """
        Sets the odata_context of this VirtualMedia100VirtualMedia.


        :param odata_context: The odata_context of this VirtualMedia100VirtualMedia.
        :type: str
        """
        self._odata_context = odata_context

    @property
    def odata_id(self):
        """
        Gets the odata_id of this VirtualMedia100VirtualMedia.


        :return: The odata_id of this VirtualMedia100VirtualMedia.
        :rtype: str
        """
        return self._odata_id

    @odata_id.setter
    def odata_id(self, odata_id):
        """
        Sets the odata_id of this VirtualMedia100VirtualMedia.


        :param odata_id: The odata_id of this VirtualMedia100VirtualMedia.
        :type: str
        """
        self._odata_id = odata_id

    @property
    def odata_type(self):
        """
        Gets the odata_type of this VirtualMedia100VirtualMedia.


        :return: The odata_type of this VirtualMedia100VirtualMedia.
        :rtype: str
        """
        return self._odata_type

    @odata_type.setter
    def odata_type(self, odata_type):
        """
        Sets the odata_type of this VirtualMedia100VirtualMedia.


        :param odata_type: The odata_type of this VirtualMedia100VirtualMedia.
        :type: str
        """
        self._odata_type = odata_type

    @property
    def connected_via(self):
        """
        Gets the connected_via of this VirtualMedia100VirtualMedia.
        Current virtual media connection methods

        :return: The connected_via of this VirtualMedia100VirtualMedia.
        :rtype: str
        """
        return self._connected_via

    @connected_via.setter
    def connected_via(self, connected_via):
        """
        Sets the connected_via of this VirtualMedia100VirtualMedia.
        Current virtual media connection methods

        :param connected_via: The connected_via of this VirtualMedia100VirtualMedia.
        :type: str
        """
        allowed_values = ["NotConnected", "URI", "Applet", "Oem"]
        if connected_via not in allowed_values:
            raise ValueError(
                "Invalid value for `connected_via`, must be one of {0}"
                .format(allowed_values)
            )
        self._connected_via = connected_via

    @property
    def description(self):
        """
        Gets the description of this VirtualMedia100VirtualMedia.
        Provides a description of this resource and is used for commonality  in the schema definitions.

        :return: The description of this VirtualMedia100VirtualMedia.
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """
        Sets the description of this VirtualMedia100VirtualMedia.
        Provides a description of this resource and is used for commonality  in the schema definitions.

        :param description: The description of this VirtualMedia100VirtualMedia.
        :type: str
        """
        self._description = description

    @property
    def id(self):
        """
        Gets the id of this VirtualMedia100VirtualMedia.
        Uniquely identifies the resource within the collection of like resources.

        :return: The id of this VirtualMedia100VirtualMedia.
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """
        Sets the id of this VirtualMedia100VirtualMedia.
        Uniquely identifies the resource within the collection of like resources.

        :param id: The id of this VirtualMedia100VirtualMedia.
        :type: str
        """
        self._id = id

    @property
    def image(self):
        """
        Gets the image of this VirtualMedia100VirtualMedia.
        A URI providing the location of the selected image

        :return: The image of this VirtualMedia100VirtualMedia.
        :rtype: str
        """
        return self._image

    @image.setter
    def image(self, image):
        """
        Sets the image of this VirtualMedia100VirtualMedia.
        A URI providing the location of the selected image

        :param image: The image of this VirtualMedia100VirtualMedia.
        :type: str
        """
        self._image = image

    @property
    def image_name(self):
        """
        Gets the image_name of this VirtualMedia100VirtualMedia.
        The current image name

        :return: The image_name of this VirtualMedia100VirtualMedia.
        :rtype: str
        """
        return self._image_name

    @image_name.setter
    def image_name(self, image_name):
        """
        Sets the image_name of this VirtualMedia100VirtualMedia.
        The current image name

        :param image_name: The image_name of this VirtualMedia100VirtualMedia.
        :type: str
        """
        self._image_name = image_name

    @property
    def inserted(self):
        """
        Gets the inserted of this VirtualMedia100VirtualMedia.
        Indicates if virtual media is inserted in the virtual device.

        :return: The inserted of this VirtualMedia100VirtualMedia.
        :rtype: bool
        """
        return self._inserted

    @inserted.setter
    def inserted(self, inserted):
        """
        Sets the inserted of this VirtualMedia100VirtualMedia.
        Indicates if virtual media is inserted in the virtual device.

        :param inserted: The inserted of this VirtualMedia100VirtualMedia.
        :type: bool
        """
        self._inserted = inserted

    @property
    def media_types(self):
        """
        Gets the media_types of this VirtualMedia100VirtualMedia.
        This is the media types supported as virtual media.

        :return: The media_types of this VirtualMedia100VirtualMedia.
        :rtype: list[str]
        """
        return self._media_types

    @media_types.setter
    def media_types(self, media_types):
        """
        Sets the media_types of this VirtualMedia100VirtualMedia.
        This is the media types supported as virtual media.

        :param media_types: The media_types of this VirtualMedia100VirtualMedia.
        :type: list[str]
        """
        self._media_types = media_types

    @property
    def name(self):
        """
        Gets the name of this VirtualMedia100VirtualMedia.
        The name of the resource or array element.

        :return: The name of this VirtualMedia100VirtualMedia.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """
        Sets the name of this VirtualMedia100VirtualMedia.
        The name of the resource or array element.

        :param name: The name of this VirtualMedia100VirtualMedia.
        :type: str
        """
        self._name = name

    @property
    def oem(self):
        """
        Gets the oem of this VirtualMedia100VirtualMedia.
        This is the manufacturer/provider specific extension moniker used to divide the Oem object into sections.

        :return: The oem of this VirtualMedia100VirtualMedia.
        :rtype: ResourceOem
        """
        return self._oem

    @oem.setter
    def oem(self, oem):
        """
        Sets the oem of this VirtualMedia100VirtualMedia.
        This is the manufacturer/provider specific extension moniker used to divide the Oem object into sections.

        :param oem: The oem of this VirtualMedia100VirtualMedia.
        :type: ResourceOem
        """
        self._oem = oem

    @property
    def write_protected(self):
        """
        Gets the write_protected of this VirtualMedia100VirtualMedia.
        Indicates the media is write protected.

        :return: The write_protected of this VirtualMedia100VirtualMedia.
        :rtype: bool
        """
        return self._write_protected

    @write_protected.setter
    def write_protected(self, write_protected):
        """
        Sets the write_protected of this VirtualMedia100VirtualMedia.
        Indicates the media is write protected.

        :param write_protected: The write_protected of this VirtualMedia100VirtualMedia.
        :type: bool
        """
        self._write_protected = write_protected

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other): 
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """ 
        Returns true if both objects are not equal
        """
        return not self == other

